#!/bin/sh
# $Id: t-alias-5.sh,v 1.3 2010/02/16 17:01:37 ca Exp $
#
# ----------------------------------------
# test alias expansion flag: replace_macros, local_domain
# uses smtpcnf.sh
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

OUT="t-alias-0.out"
LUM="lu.db"
HOSTNAME=`../libmta/t-hostname -l -V 2>/dev/null`

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
user++:	local:
sender: local:
@s.local.dom:     user+\${user}
@n.local.dom:     \${user}
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
s.local.dom	lmtp:
n.local.dom	lmtp:
local.dom	lmtp:
alsolocal.dom	lmtp:
${HOSTNAME}	lmtp:
some.dom	[127.0.0.1]
other.dom	[127.0.0.1]
remote.dom	[127.0.0.1]
EOF

# ----------------------------------------
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4; }
smar {
aliases { flags = {replace_macros, domain, local_domains} }
Log_Level = 12;
nameserver = ${NS};
DNS_timeout = 5;
}
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }
smtps {
Log_Level = 14;
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
}
EOF

# ----------------------------------------
# test: send mail to local address which is an alias

TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -3 lmtpsock -Ssender@local.dom -Rlocalpart@s.local.dom -E 0 -X 0 -A 1
then
  if test -s ${B1}
  then
    :
  else
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
rm -f ${B1}
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# # ----------------------------------------
# # test: send mail to local address which is an alias that eventually
# # points to an address that cannot be accepted
# # Note: RCPT verification checks only the first level (does the alias
# # exist), so the RCPT is NOT rejected but bounced later on...
# 
# TEST=2
# if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
# then
# ERR=false
# 
# if ${SHELL} ${SD}/smtpcnf.sh -3 lmtpsock -Ssender@local.dom -Runknownlocalpart@n.local.dom -E 0 -X 0 -A 1
# then
#   if test -s ${B1}
#   then
#     :
#   else
#     ERR=true
#   fi
# else
#   ERR=true
# fi
# if ${ERR}
# then
#    echo "$0: test ${TEST} failed"
#    ERRS=`expr ${ERRS} + 1 `
#    test X"${MTA_STOPONERROR}" != X && exit 1
# fi
# rm -f ${B1}
# else
#   ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
# fi


rm -f ${MTMAP} ${ALIMAP}

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
