/*
 * Copyright (c) 2010 Claus Assmann
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the license/LICENSE.3C file which can be found at the
 * top level of this source code distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: arg2smtpreply.c,v 1.3 2011/01/08 00:01:33 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/string.h"
#include "sm/enhsc.h"
#include "sm/misc.h"
#include "sm/smreplycodes.h"

char *
arg2smtpreply(const char *txt, const char *dflt, bool enhsc)
{
	size_t len;
	int r;
	const char *text;
	char *resp;
	char enhscbuf[10];

	if (!IS_SMTP_CODE(txt, 0))
		return NULL;
	sm_snprintf(enhscbuf, sizeof(enhscbuf),	"%c.%c.%c", txt[0], txt[1], txt[2]);

	len = strlen(txt) + sizeof(enhscbuf) + 3;
	if (txt[3] != '_')
		len += strlen(dflt);
	resp = malloc(len);
	if (NULL == resp) return NULL;

	resp[0] = txt[0];
	resp[1] = txt[1];
	resp[2] = txt[2];
	resp[3] = ' ';
	resp[4] = '\0';

	if (txt[3] != '_')
		text = dflt;
	else {
		text = txt + 4;
		if (enhsc && (r = extenhsc(text, '_', enhscbuf)) > 0)	\
			text += r + 1;
	}
	if (enhsc) {
		strlcat(resp, enhscbuf, len);
		strlcat(resp, " ", len);
	}
	(void) convbackslash(text, resp + strlen(resp));
	strlcat(resp, "\r\n", len);
	tr_simple(resp, "_", " ");
	return resp;
}
