/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: binsearch.c,v 1.2 2010/06/12 01:54:52 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/binsearch.h"

/*
 * how to make this generic?
 * pass:
 * void *tab
 * size of each entry
 * offset to id
 * simpler: define a macro, see include/sm/binsearch.h
 */

sm_ret_T
sm_binsearch(sm_identry_P idtab, int sz, const char *id, int *pidx)
{
	int cmp, low, mid, high;

	SM_REQUIRE(id != NULL);
	SM_REQUIRE(pidx != NULL);
	SM_REQUIRE(idtab != NULL);
	SM_REQUIRE(sz > 0);

	low = 0;
	high = sz - 1;
	while (low <= high) {
		mid = (low + high) / 2;
		cmp = strcmp(id, idtab[mid].idt_id);
		if (cmp == 0) {
			*pidx = mid;
			return SM_SUCCESS;
		}
		else if (cmp < 0)
			high = mid - 1;
		else if (cmp > 0)
			low = mid + 1;
	}
	return sm_err_perm(SM_E_NOTFOUND);
}
