/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: strcmpn.c,v 1.1 2014/06/01 00:41:10 ca Exp $")

#include "sm/assert.h"
#include "sm/magic.h"
#include "sm/memops.h"
#include "sm/rpool.h"
#include "sm/str.h"
#include "sm/str-int.h"

/*
**  SM_STR_CMPN -- Compare two strings up to n chars.
**
**	Parameters:
**		s1 -- first string
**		s2 -- second string
**		n -- max length to check
**
**	Returns:
**		0: strings are equal up to n chars
**		<0: 1. string < 2. string
**		>0: 1. string > 2. string
*/

int
sm_str_cmpn(const sm_str_P s1, const sm_str_P s2, uint n)
{
	int d, r;
	uint l;

	SM_IS_BUF(s1);
	SM_IS_BUF(s2);
	l = s1->sm_str_len;
	if (l > s2->sm_str_len) {
		d = 1;
		l = s2->sm_str_len;
	}
	else if (l == s2->sm_str_len)
		d = 0;
	else
		d = -1;
	if (l >= n) {
		l = n;
		d = 0;
	}
	r = sm_memcmp(s1->sm_str_base, s2->sm_str_base, l);
	if (r == 0)
		r = d;
	return r;
}
