#!/bin/sh
# $Id: t-stop-dep-1.sh,v 1.1 2014/01/06 21:40:32 ca Exp $
#
# Copyright (c) 2014 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test restart functionality of mcp:
# "server" fails fatally.
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
L1=smar.log
L2=qmgr.log
. ${SD}/common.sh

for i in smar qmgr
do
  rm -f $i
  ln -s ${PRG} $i
done

cat > ${CONF} <<EOF
smar {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./smar;
	restart_dependencies = { qmgr };
	arguments = "smar -p ${PIDF1} -f ${R1} -n 10 -VV -s 1 -U";
}
qmgr {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./qmgr;
	restart_dependencies = {smar};
	arguments = "qmgr -p ${PIDF2} -f ${R2} -n 10 -VV -s 4 -T";
}
EOF

echo 0 > ${R1}
echo 0 > ${R2}
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

waitforfile ${PIDF1}
waitforfile ${PIDF2}

# give it time to restart several times then fail
sleep 10

# check that programs behaved properly
if grep 'service=smar, .*status=server failed with unrecoverable error' ${OUT} >/dev/null
then
  :
else
  echo "$0: ERROR: missing 'server failed too often' in ${OUT}"
  ERRS=`expr ${ERRS} + 1 `
fi
C=`grep -c 'execl ./smar' ${OUT}`
if [ X"$C" != "X1" ]
then
  echo "$0: ERROR: wrong number of execl smar: ${C}"
  ERRS=`expr ${ERRS} + 1 `
fi

C=`grep -c 'execl ./qmgr' ${OUT}`
if [ X"$C" != "X1" ]
then
  echo "$0: ERROR: wrong number of execl qmgr: ${C}"
  ERRS=`expr ${ERRS} + 1 `
fi

stopit
testend
