#!/bin/awk -f
# check whether PIPELINING was ok.
# method: look for DATA command, then for the replies received afterwards
# before "From:" is sent. the last reply must be "354".
#
# $Id: pcheck.awk,v 1.1 2010/09/13 03:32:44 ca Exp $
#
/send: DATA/ {
  do {
    getline;
    if ($2 == "rcvd") {
      CF=NF-1;
      CODE=$CF;
    }
  } while ($2 == "rcvd");
  if (Verbose) { print "code=", CODE, FNR; }
  if (Verbose) { print "next: ",$2, $3; }
  if ($2 == "send:" && $3 == "From:" && CODE != 354) {
    if (Verbose) { print "ERROR", FNR, "\n", $0; }
    exit 1;
  }
}
